SystemOrganization addCategory: #'Fuel-Core'!
SystemOrganization addCategory: #'Fuel-Core-Clusters'!
SystemOrganization addCategory: #'Fuel-Core-Mappers'!
SystemOrganization addCategory: #'Fuel-Core-Errors'!
SystemOrganization addCategory: #'Fuel-Collections'!
SystemOrganization addCategory: #'Fuel-Streams'!
SystemOrganization addCategory: #'Fuel-Utilities'!

Trait named: #FLTWithClass
	uses: {}
	category: 'Fuel-Core-Clusters'!

!FLTWithClass classSide methodsFor: 'instance creation' stamp: 'MartinDias 5/30/2011 03:33'!
for: aClass

	^ self basicNew
		theClass: aClass;
		yourself.! !

!FLTWithClass methodsFor: 'comparing' stamp: 'MartinDias 5/30/2011 03:33'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ self theClass = anObject theClass! !

!FLTWithClass methodsFor: 'comparing' stamp: 'MartinDias 5/30/2011 03:33'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ self theClass hash! !

!FLTWithClass methodsFor: 'printing' stamp: 'MartinDias 5/30/2011 03:33'!
printOn: aStream
	"Append to the argument, aStream, a sequence of characters that  
	identifies the receiver."
	
	super printOn: aStream.
	aStream nextPut: $(.
	self theClass printOn: aStream.
	aStream nextPut: $).
	! !

!FLTWithClass methodsFor: 'accessing' stamp: 'MartinDias 5/30/2011 03:33'!
theClass

	self explicitRequirement ! !

!FLTWithClass methodsFor: 'accessing' stamp: 'MartinDias 5/30/2011 03:33'!
theClass: aClass

	self explicitRequirement ! !

!Metaclass methodsFor: '*Fuel' stamp: 'MartinDias 10/19/2010 10:50'!
fuelAccept: aVisitor

	aVisitor visitMetaclass: self! !

!Metaclass methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster 

	^ FLClassSideCluster instance.! !

!TraitBehavior methodsFor: '*Fuel' stamp: 'MartinDias 3/28/2011 02:45'!
initializeTraitComposition: aTraitComposition

	self traitComposition: aTraitComposition.
	aTraitComposition traits do: [:each | each addUser: self]! !

!TraitBehavior methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 5/21/2011 20:10'!
printCompactHierarchy
	"Returns a short description of the class hierarchy"
	
	^ self withAllSuperclasses inject: '' into: [:a :b | b printString, '.', a ]! !

!ByteString methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 5/22/2011 20:15'!
fuelAccept: aVisitor

	aVisitor visitObject: self! !

!ByteString methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster

	^ FLByteStringCluster instance! !

!ContextPart class methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 5/22/2011 23:44'!
newFromFrameSize: aFrameSize
	
	^ super basicNew: aFrameSize! !

!ByteSymbol methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 5/22/2011 20:16'!
fuelAccept: aVisitor

	aVisitor visitObject: self! !

!ByteSymbol methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster

	^ FLSymbolCluster instance! !

!OrderedCollection methodsFor: '*Fuel' stamp: 'MartinDias 10/12/2010 16:11'!
hasAnyDuplicate
	"Answers if there is an element added more than one time"

	^ self size ~= self asSet size ! !

!HashedCollection methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster

	^ FLHashedCollectionCluster for: self class! !

!SmallInteger methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster

	^ FLSmallIntegerCluster for: self! !

Stream subclass: #FLBufferedWriteStream
	instanceVariableNames: 'stream buffer position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Streams'!

!FLBufferedWriteStream class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
on: writeStream
	^ self basicNew
		on: writeStream;
		yourself! !

!FLBufferedWriteStream class methodsFor: 'convenience' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
on: writeStream do: block
	"Execute block with as argument a ZnBufferedWriteStream on writeStream,
	making sure #flush is called at the end."
	
	| bufferedWriteStream |
	bufferedWriteStream := self on: writeStream.
	block value: bufferedWriteStream.
	bufferedWriteStream flush! !

!FLBufferedWriteStream methodsFor: 'private' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
buffer
	buffer isNil 
		ifTrue: [ self sizeBuffer: self defaultBufferSize ].
	^ buffer! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
bufferFreeSize
	^ self bufferSize - position! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
bufferSize
	^ buffer isNil 
		ifTrue: [ self defaultBufferSize ]
		ifFalse: [ buffer size ]! !

!FLBufferedWriteStream methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
close
	self flushBuffer.
	stream close! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
defaultBufferSize
	^ 8192 "2 raisedTo: 13  "
	

! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
flush
	self flushBuffer.
	stream flush! !

!FLBufferedWriteStream methodsFor: 'private' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
flushBuffer
	position = 0 ifTrue: [ ^ self ].
	position = self bufferSize
		ifTrue: [
			stream nextPutAll: buffer ]
		ifFalse: [
			(stream respondsTo: #next:putAll:startingAt:)
				ifTrue: [ stream next: position putAll: buffer startingAt: 1 ]
				ifFalse: [ stream nextPutAll: (buffer copyFrom: 1 to: position) ] ].
	position := 0! !

!FLBufferedWriteStream methodsFor: 'private' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
flushBufferIfFull
	position = self bufferSize 
		ifTrue: [ self flushBuffer ]
! !

!FLBufferedWriteStream methodsFor: 'printing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
nextInt32Put: int32
	"Write a signed integer to the next 4 bytes"
	| pos |
	self flushBufferIfFull.
	pos := int32 < 0
		ifTrue: [(0-int32) bitInvert32 + 1]
		ifFalse: [int32].
	1 to: 4 do: [:i | self nextPut: (pos digitAt: 5-i)].
	^ int32! !

!FLBufferedWriteStream methodsFor: 'writing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
nextNumber: n put: v 
	"Append to the receiver the argument, v, which is a positive 
	SmallInteger or a LargePositiveInteger, as the next n bytes.
	Possibly pad with leading zeros."
	self flushBufferIfFull.
	1 to: n do: [:i | self nextPut: (v digitAt: n+1-i)].
	^ v
! !

!FLBufferedWriteStream methodsFor: 'writing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
nextPut: object
	self flushBufferIfFull.
	position := position + 1.
	self buffer at: position put: object! !

!FLBufferedWriteStream methodsFor: 'writing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
nextPutAll: collection
	self flushBufferIfFull.
	collection size <= self bufferFreeSize
		ifTrue: [
			self buffer replaceFrom: position + 1 to: position + collection size with: collection.
			position := position + collection size ]
		ifFalse: [
			self flushBuffer.
			collection size > (self bufferSize / 2)
				ifTrue: [ stream nextPutAll: collection ]
				ifFalse: [ self nextPutAll: collection ] ]
! !

!FLBufferedWriteStream methodsFor: 'writing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
nextStringPut: s 
	"Append the string, s, to the receiver.  Only used by DataStream.  Max size of 64*256*256*256."

	| length |
	self flushBufferIfFull.
	(length := s size) < 192
		ifTrue: [self nextPut: length]
		ifFalse: 
			[self nextPut: (length digitAt: 4)+192.
			self nextPut: (length digitAt: 3).
			self nextPut: (length digitAt: 2).
			self nextPut: (length digitAt: 1)].
	self nextPutAll: s asByteArray.
	^s! !

!FLBufferedWriteStream methodsFor: 'writing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
nextWordPut: aWord 
	"Append to the receiver an Integer as the next two bytes."
	self flushBufferIfFull.
	self nextPut: ((aWord bitShift: -8) bitAnd: 255).
	self nextPut: (aWord bitAnd: 255).
	^aWord! !

!FLBufferedWriteStream methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
on: writeStream
	stream := writeStream.
	position := 0! !

!FLBufferedWriteStream methodsFor: 'printing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
printOn: aStream
	aStream 
		nextPutAll: 'a '; 
		nextPutAll: self class name! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
sizeBuffer: size
	buffer := (stream isBinary ifTrue: [ ByteArray ] ifFalse: [ String ]) new: size! !

!FLBufferedWriteStream methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/17/2011 23:32'!
space
	self nextPut: Character space! !

!Trait methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:23'!
fuelAccept: aVisitor

	aVisitor visitClassOrTrait: self! !

!Trait methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster 

	^FLTraitCluster instance! !

!CompiledMethod methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster 

	^ (self isNamedPrimitive)
		ifTrue:  [ FLNamedPrimitiveMethodCluster instance ]
		ifFalse: [ FLCompiledMethodCluster instance ]
! !

!CompiledMethod methodsFor: '*Fuel' stamp: 'MartinDias 10/22/2010 12:56'!
isNamedPrimitive 

	^ self primitive = 117! !

!Set methodsFor: '*Fuel' stamp: 'MartinDias 5/19/2011 23:33'!
addIfNotPresent: anObject ifPresentDo: aBlock

	| index |
	anObject ifNil: [self error: 'Sets cannot meaningfully contain nil as an element'].
	index := self findElementOrNil: anObject.
	(array at: index) 
		ifNil: [ self atNewIndex: index put: anObject ]
		ifNotNil: [ aBlock value ].
	^ anObject! !

!Set methodsFor: '*Fuel' stamp: 'MartinDias 5/19/2011 22:44'!
addIfNotPresent: anObject thenDo: aBlock
	"Include anObject as one of the receiver's elements and then value aBlock, but only if there
	is no such element already. Anwser anObject."

	| index |
	anObject ifNil: [self error: 'Sets cannot meaningfully contain nil as an element'].
	index := self findElementOrNil: anObject.
	(array at: index) ifNil: [
		self atNewIndex: index put: anObject.
		aBlock value ].
	^ anObject! !

!MethodContext methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 5/22/2011 22:58'!
closure: aClosureOrNil 
	closureOrNil := aClosureOrNil 
	! !

!MethodContext methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster 

	^ FLMethodContextCluster instance
! !

!MethodContext methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 5/22/2011 23:07'!
initializeWith: aPc stackPtr: aStackPtr method: aMethod receiver: aReceiver sender: aSender
	pc := aPc.
	stackp := aStackPtr.
	method := aMethod.
	receiver := aReceiver.
	sender := aSender.
	! !

!MethodContext methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 5/22/2011 22:11'!
method: aMethod

	method := aMethod ! !

!Behavior methodsFor: '*Fuel' stamp: 'MartinDias 10/12/2010 10:54'!
hasInstanceVariables
	"Returns whether the receiver has instance variables"
	
	^ self instSize > 0 ! !

!Behavior methodsFor: '*Fuel' stamp: 'MartinDias 3/28/2011 02:39'!
initializeTraitComposition: aTraitComposition

	aTraitComposition assertValidUser: self.
	self traitComposition: aTraitComposition.
	aTraitComposition traits do: [:each | each addUser: self]! !

!Behavior methodsFor: '*Fuel' stamp: 'MartinDias 3/17/2011 16:36'!
printCompactHierarchy
	"Returns a short description of the class hierarchy"
	
	^ self withAllSuperclasses inject: '' into: [:a :b | b printString, '.', a ]! !

!ClassTrait methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster 

	^ FLClassSideCluster instance.! !

!MethodDictionary methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster 

	^ FLMethodDictionaryCluster instance! !

Error subclass: #FLClassNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Errors'!

!UndefinedObject methodsFor: '*Fuel' stamp: 'MartinDias 10/19/2010 10:50'!
fuelAccept: aVisitor

	aVisitor visitNilTrueFalse: self.! !

!UndefinedObject methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster 

	^ FLNilTrueFalseCluster instance! !

!Collection methodsFor: '*Fuel' stamp: 'MartinDias 5/19/2011 23:41'!
addIfNotPresent: anObject ifPresentDo: aBlock
	"Include anObject as one of the receiver's elements and then value aBlock, but only if there
	is no such element already. Anwser anObject."

	(self includes: anObject) 
		ifFalse: [ self add: anObject ]
		ifTrue: [ aBlock value ].
	^ anObject! !

!Collection methodsFor: '*Fuel' stamp: 'MartinDias 5/19/2011 22:43'!
addIfNotPresent: anObject thenDo: aBlock
	"Include anObject as one of the receiver's elements and then value aBlock, but only if there
	is no such element already. Anwser anObject."

	(self includes: anObject) ifFalse: [ 
		self add: anObject. 
		aBlock value ].
	^ anObject! !

!Float methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 5/22/2011 20:16'!
fuelAccept: aVisitor

	aVisitor visitObject: self! !

!Float methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster 

	^ FLFloatCluster instance! !

!Integer methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 5/22/2011 20:16'!
fuelAccept: aVisitor

	aVisitor visitObject: self! !

!Character methodsFor: '*Fuel' stamp: 'MarianoMartinezPeck 5/22/2011 20:16'!
fuelAccept: aVisitor

	aVisitor visitObject: self! !

!Character methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster

	^ FLCharacterCluster instance! !

!ArrayedCollection methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster

	^ (self class isPointers not and: [self class isWords])
		ifTrue: [(FLRawArrayedCollectionCluster for: self class)]
		ifFalse: [super fuelCluster].! !

!Class methodsFor: '*Fuel' stamp: 'MartinDias 5/14/2011 21:44'!
basicSubclasses

	^ subclasses! !

!Class methodsFor: '*Fuel' stamp: 'MartinDias 5/14/2011 21:45'!
basicSubclasses: anArray

	subclasses := anArray! !

!Class methodsFor: '*Fuel' stamp: 'MartinDias 10/25/2010 15:23'!
fuelAccept: aVisitor

	aVisitor visitClassOrTrait: self! !

!Class methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster 

	^ FLClassCluster instance ! !

!Boolean methodsFor: '*Fuel' stamp: 'MartinDias 10/19/2010 10:50'!
fuelAccept: aVisitor

	aVisitor visitNilTrueFalse: self.! !

!Boolean methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster 

	^ FLNilTrueFalseCluster instance ! !

!ByteArray methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster 

	^ FLByteArrayCluster instance! !

Object subclass: #FLAnalyzer
	instanceVariableNames: 'objectCount objectStack mapper clustersWithBaselevelObjects clustersWithExternalMetalevelObjects clustersWithInternalMetalevelObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLAnalyzer commentStamp: 'MartinDias 5/30/2011 03:21' prior: 0!
I am responsible of traverse the graph of references starting on a collection of root objects. I will produce dictionaries that associate each traversed object to a serializer.

An example of use is

	FLAnalyzer newDefault 
		analyze: { 1@2. 3@4 };
		clusteredObjects.
	
The results are used by FLSerializer to serialize the analyzed objects into a stream.!

!FLAnalyzer class methodsFor: 'instance creation' stamp: 'MartinDias 10/26/2010 10:32'!
new

	self error: 'Should use an specific instance creation message.'! !

!FLAnalyzer class methodsFor: 'instance creation' stamp: 'MartinDias 5/30/2011 02:15'!
newDefault

	^ self basicNew 
		initialize; 
		initializeDefaultMappers;
		yourself! !

!FLAnalyzer class methodsFor: 'instance creation' stamp: 'MartinDias 5/30/2011 01:57'!
newDefaultInternalObjects: aCollection
	"Returns an instance with default configuration, declaring an internal the objects in the collection."

	| analyzer globalAssociationAnalyzer globalAnalyzer classPoolAssociationAnalyzer |
	analyzer := self basicNew 
		initialize; 
		yourself.
		
	self flag: #todo. "Reify configuration and remove this crap"
	
	globalAssociationAnalyzer := (FLGlobalAssociationMapper newWith: analyzer)
		internalGlobals: aCollection;
		yourself.
	
	globalAnalyzer := (FLGlobalMapper newWith: analyzer) 
		internalGlobals: aCollection; 
		yourself.
		
	classPoolAssociationAnalyzer := (FLClassPoolAssociationMapper newWith: analyzer) 
		internalClasses: aCollection; 
		yourself.
		
	analyzer mappers 
		add: globalAssociationAnalyzer;
		add: classPoolAssociationAnalyzer;
		add: globalAnalyzer;
		add: (FLDefaultMapper newWith: analyzer).
		
	^ analyzer! !

!FLAnalyzer methodsFor: 'analyzing' stamp: 'MartinDias 5/30/2011 01:58'!
analyze: anObject

	objectStack push: anObject.

	[ objectStack isEmpty ] 
		whileFalse: [ self map: objectStack pop ]
! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 5/30/2011 03:20'!
clusteredObjects
	"Returns a new collection with all the clustered objects, in Association instances."
	
	"Be careful that the order of the #addAll: is imporant in this case."
	^ (OrderedCollection new: 
			clustersWithExternalMetalevelObjects size + 
			clustersWithInternalMetalevelObjects size + 
			clustersWithBaselevelObjects size) 
		addAll: clustersWithExternalMetalevelObjects associations;
		addAll: clustersWithInternalMetalevelObjects associations;
		addAll: clustersWithBaselevelObjects associations;
		yourself.! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 5/30/2011 03:19'!
clustersWithBaselevelObjects
	
	^ clustersWithBaselevelObjects! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 5/30/2011 03:20'!
clustersWithExternalMetalevelObjects
	
	^ clustersWithExternalMetalevelObjects ! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 5/30/2011 03:20'!
clustersWithInternalMetalevelObjects
	
	^ clustersWithInternalMetalevelObjects ! !

!FLAnalyzer methodsFor: 'initialize-release' stamp: 'MartinDias 5/30/2011 03:20'!
initialize

	objectStack := FLSimpleStack new.
	clustersWithBaselevelObjects := Dictionary new.
	clustersWithExternalMetalevelObjects := Dictionary new.
	clustersWithInternalMetalevelObjects := Dictionary new.
	objectCount := 0.
	mapper := OrderedCollection new.
! !

!FLAnalyzer methodsFor: 'initialize-release' stamp: 'MartinDias 5/30/2011 02:15'!
initializeDefaultMappers

	mapper 
		add: (FLGlobalAssociationMapper newWith: self);
		add: (FLClassPoolAssociationMapper newWith: self);
		add: (FLGlobalMapper newWith: self);
		add: (FLDefaultMapper newWith: self)
! !

!FLAnalyzer methodsFor: 'mapping' stamp: 'MartinDias 5/30/2011 02:22'!
map: anObject

	(self mapperFor: anObject) map: anObject ! !

!FLAnalyzer methodsFor: 'mapping' stamp: 'MartinDias 5/30/2011 02:18'!
map: anObject to: aCluster into: aDictionary
	"Associates anObject to aCluster."

	self 
		map: anObject 
		to: aCluster 
		into: aDictionary 
		blockForNewCollection: [ IdentitySet new ]
! !

!FLAnalyzer methodsFor: 'mapping' stamp: 'MartinDias 5/30/2011 02:20'!
map: anObject to: aCluster into: aDictionary blockForNewCollection: aBlock
	"Associates anObject to aCluster. If it is the first object for this cluster, values aBlock to create a collection to add it."

	| clusterObjects |
	clusterObjects := 
		aDictionary 
			at: aCluster 
			ifAbsentPut: [ aBlock value ].

	clusterObjects 
		addIfNotPresent: anObject
		ifPresentDo: [ ^self ].
		 
	objectCount := objectCount + 1.
	(clusterObjects size = 1) ifTrue: [ aCluster clusterReferencesDo: [ :aChild | objectStack push: aChild ] ].
	aCluster referencesOf: anObject do: [ :aChild | objectStack push: aChild ]! !

!FLAnalyzer methodsFor: 'mapping' stamp: 'MartinDias 5/30/2011 02:01'!
mapperFor: anObject

	^ mapper detect: [ :anAnalyzer | anAnalyzer accepts: anObject ].
! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 5/30/2011 01:57'!
mappers
	^ mapper! !

!FLAnalyzer methodsFor: 'accessing' stamp: 'MartinDias 10/19/2010 10:31'!
objectCount

	^ objectCount! !

Object subclass: #FLCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

FLCluster class
	instanceVariableNames: 'instance serializersById'!

!FLCluster commentStamp: '<historical>' prior: 0!
I represent a special way of serializing and materializing some specific kind of objects.

Each of my non-abstract subclasses answers to #id with an unique integer, that identifies it. 

Sending me the #forId: message you obtain an instance that corresponds with an specific id. 

Every object responds to #fuelSerializer with its corresponding subclass of me. For example:

	42 fuelSerializer 
	
will return a serializer for that specific instance of SmallInteger.!

FLCluster class
	instanceVariableNames: 'instance serializersById'!

!FLCluster class methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 15:24'!
allSubclassesWithId
	"Answers a collection with all the subclasses that define an id. In other words, all the non-abstract subclasses are returned"

	^self allSubclasses select: [ :aClass | 
			[ aClass id isInteger ] ifError: [ false ] ] 
	! !

!FLCluster class methodsFor: 'instance creation' stamp: 'MartinDias 10/18/2010 12:34'!
forId: anInteger
	"Returns the serializer instance that corresponds to the id received"

	^ self serializersById 
			at: anInteger 
			ifAbsent: [ self error: 'Could not find a serializer with id=', anInteger asString ].
	
! !

!FLCluster class methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:56'!
id
	"Answer an integer identifier. It must be between 0 and 255. 
	Each type of primitive object should have a different one. 
	validateIdDistribution checks that there is no overlap."
	
	self subclassResponsibility ! !

!FLCluster class methodsFor: 'class initialization' stamp: 'MartinDias 5/13/2011 10:20'!
initialize

	self resetHierarchy! !

!FLCluster class methodsFor: 'instance creation' stamp: 'MartinDias 10/15/2010 11:29'!
instance
	"Returns the singleton instance of this class. It may not be sent to abstract classes, see class doc."
	
	^ instance ifNil: [ instance := self basicNew initialize ]
	
! !

!FLCluster class methodsFor: 'class initialization' stamp: 'MartinDias 3/21/2011 17:33'!
reset
	"Resets singleton class variables"

	instance := nil.
	serializersById := nil.! !

!FLCluster class methodsFor: 'class initialization' stamp: 'MartinDias 3/21/2011 17:34'!
resetHierarchy
	"Resets class variables in the whole hierarchy"

	self withAllSubclasses do: [ :x | x reset ]! !

!FLCluster class methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 15:16'!
serializersById
	"Returns a dictionary that indexes the serializers by their ids"

	serializersById ifNil: [
			serializersById := IdentityDictionary new.
			self allSubclassesWithId 
				do: [ :aSerializerClass | 
					serializersById 
						at: aSerializerClass id 
						put: aSerializerClass instance ] ].
	^ serializersById 
! !

!FLCluster class methodsFor: 'checking' stamp: 'MartinDias 10/12/2010 16:06'!
validateIdDistribution
	"Verifies that subclasses do not have overlapping ids"
	
	self assert: (self allSubclassesWithId collect: [ :aClass | aClass id ]) hasAnyDuplicate not
		description: 'Overlapping id detected in FLClusterSerializer subclasses'! !

!FLCluster methodsFor: 'analyzing' stamp: 'MartinDias 4/19/2011 19:53'!
clusterReferencesDo: aBlock
	"Evaluates the received block with each object referenced by the cluster"! !

!FLCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 11:35'!
materializeAllWith: aMaterializer

	self subclassResponsibility ! !

!FLCluster methodsFor: 'analyzing' stamp: 'MartinDias 3/2/2011 23:07'!
referencesOf: anObject do: aBlock
	"Evaluates the received block with each object referenced by anObject"! !

!FLCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 11:11'!
serializeAll: clusterInstances with: aSerializer

	self subclassResponsibility ! !

FLCluster subclass: #FLIteratingCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLIteratingCluster commentStamp: '<historical>' prior: 0!
I am a template class whose algorithm for serialize a collection of objects consists on delegate the serialization of each individual object to the subclass.!

FLIteratingCluster subclass: #FLClassOrTraitCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLClassOrTraitCluster commentStamp: '<historical>' prior: 0!
I have the common behavior for serializing a class or a trait with full detail. The class or trait will be recreated completely on the materializing image.!

FLClassOrTraitCluster subclass: #FLClassCluster
	instanceVariableNames: ''
	classVariableNames: 'SubclassSelectors'
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLClassCluster commentStamp: 'MartinDias 5/30/2011 01:17' prior: 0!
I am a cluster for classes with full detail. The class will be recreated completely on the materializing image.

TODO: describe different scenarios for materialization:

- when the class already exists in the image:
-- the class' format changes (for example, #isVariable changes its value)
-- the instance variables are different

- when the superclass doesn't exist

- other!

!FLClassCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 3/2/2011 23:09'!
id
	^ 17! !

!FLClassCluster classSide methodsFor: 'initialize-release' stamp: 'MartinDias 3/29/2011 22:35'!
initialize

	SubclassSelectors := Dictionary new
		at: #normal put: #subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:;
		at: #weak put: #weakSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category:;
		at: #variable put: #variableSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category:;
		at: #bytes put: #variableByteSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category:;
		at: #words put: #variableWordSubclass:instanceVariableNames:classVariableNames:poolDictionaries:category:;
		at: #compiledMethod put: #subclass:instanceVariableNames:classVariableNames:poolDictionaries:category:;
		yourself.! !

!FLClassCluster methodsFor: 'private' stamp: 'MartinDias 3/18/2011 15:58'!
hackedClassPool: aClass

	self flag: #todo. "fix reifying better the graph iteration"
	^ aClass classPool isEmpty ifTrue: [ nil ] ifFalse: [ aClass classPool ]
	! !

!FLClassCluster methodsFor: 'private' stamp: 'MartinDias 3/20/2011 14:44'!
hackedSharedPools: aClass

	self flag: #todo. "fix reifying better the graph iteration"
	^ aClass sharedPools isEmpty ifTrue: [ nil ] ifFalse: [ aClass sharedPools ]
	! !

!FLClassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 02:59'!
materializeInstanceWith: aMaterializer

	| aClass superclass category name instanceVariableNames classSideInstanceVariableNames format newSuperMeta newMeta metaclassFormat |
	superclass := aMaterializer nextReferencedObject.
	category := aMaterializer stream nextString asSymbol.
	name := aMaterializer stream nextString asSymbol.
	instanceVariableNames := aMaterializer stream nextString subStrings: ' '. "So that to get the expected Array "
	classSideInstanceVariableNames := aMaterializer stream nextString subStrings: ' '. "So that to get the expected Array "
	format := aMaterializer stream nextWord.
	metaclassFormat := aMaterializer stream nextWord.

	"Metaclass stuff and class creation"
	newSuperMeta := superclass ifNil:[Class] ifNotNil:[superclass class].
	newMeta := Metaclass new.
	newMeta 
		"this data will then be overwritten"
		superclass: newSuperMeta 
		methodDictionary: MethodDictionary new 
		format: metaclassFormat.
	newMeta setInstVarNames: classSideInstanceVariableNames.
	aClass := newMeta new.
	
	aClass 
		superclass: superclass;
		setFormat: format;
		setInstVarNames: instanceVariableNames; "check how they come"
		setName: name;
		basicCategory: category.

	"grrrr need to remoe thissss"
"	Smalltalk globals at: name put: aClass.
	Smalltalk globals flushClassNameCache."

	^aClass! !

!FLClassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/14/2011 21:48'!
materializeReferencesOf: aClass with: aMaterializer

	super materializeReferencesOf: aClass with: aMaterializer.

	aClass classPool: aMaterializer nextReferencedObject.
	aClass sharedPools: aMaterializer nextReferencedObject.
	aClass basicSubclasses: aMaterializer nextReferencedObject. 
	
	Class class instSize + 1 to: aClass class instSize 
		do: [ :index | aClass instVarAt: index put: aMaterializer nextReferencedObject ]! !

!FLClassCluster methodsFor: 'analyzing' stamp: 'MartinDias 5/14/2011 21:49'!
referencesOf: aClass do: aBlock

	super referencesOf: aClass do: aBlock.
	
	aBlock value: aClass superclass.
	aBlock value: (self hackedClassPool: aClass).
	aBlock value: (self hackedSharedPools: aClass). 
	aBlock value: aClass basicSubclasses. 

	Class class instSize + 1 to: aClass class instSize 
		do: [ :index | aBlock value: (aClass instVarAt: index) ]! !

!FLClassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 03:00'!
serializeInstance: aClass with: aSerializer

	aSerializer nextPutReferenceTo: aClass superclass.
	aSerializer stream nextStringPut: aClass basicCategory.
	aSerializer stream nextStringPut: aClass name.
	aSerializer stream nextStringPut: aClass instanceVariablesString.
	aSerializer stream nextStringPut: aClass class instanceVariablesString.
	aSerializer stream nextWordPut: aClass format.
	aSerializer stream nextWordPut: aClass class format.
	! !

!FLClassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/14/2011 21:51'!
serializeReferencesOf: aClass with: aSerializer

	super serializeReferencesOf: aClass with: aSerializer.

	aSerializer nextPutReferenceTo: (self hackedClassPool: aClass). 
	aSerializer nextPutReferenceTo: (self hackedSharedPools: aClass). 
	aSerializer nextPutReferenceTo:  aClass basicSubclasses.
 
	Class class instSize + 1 to: aClass class instSize 
		do: [ :index | aSerializer nextPutReferenceTo: (aClass instVarAt: index) ]! !

!FLClassOrTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 22:14'!
materializeInstanceWith: aMaterializer
	
	self explicitRequirement! !

!FLClassOrTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 23:47'!
materializePostReferencesOf: aClassOrTrait with: aMaterializer

	aClassOrTrait initializeTraitComposition: aMaterializer nextReferencedObject.
	aClassOrTrait classSide initializeTraitComposition: aMaterializer nextReferencedObject.! !

!FLClassOrTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 23:47'!
materializeReferencesOf: aClassOrTrait with: aMaterializer

	aClassOrTrait methodDictionary: aMaterializer nextReferencedObject.
	aClassOrTrait organization: aMaterializer nextReferencedObject.
	aClassOrTrait basicLocalSelectors: aMaterializer nextReferencedObject.
	
	aClassOrTrait classSide methodDictionary: aMaterializer nextReferencedObject.
	aClassOrTrait classSide organization: aMaterializer nextReferencedObject.
	aClassOrTrait classSide basicLocalSelectors: aMaterializer nextReferencedObject.! !

!FLClassOrTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 23:37'!
materializeWith: aMaterializer

	| classOrTrait |
	classOrTrait := self materializeInstanceWith: aMaterializer.
	
	aMaterializer referenceMaterializingActionsAdd: [ 
		self materializeReferencesOf: classOrTrait with: aMaterializer ].

	aMaterializer postReferenceMaterializingActionsAdd: [ 
		self materializePostReferencesOf: classOrTrait with: aMaterializer ].

	^classOrTrait! !

!FLClassOrTraitCluster methodsFor: 'analyzing' stamp: 'MartinDias 3/29/2011 23:48'!
referencesOf: aClassOrTrait do: aBlock

	aBlock value: aClassOrTrait methodDictionary.
	aBlock value: aClassOrTrait organization.
	aBlock value: aClassOrTrait traitComposition.
	aBlock value: aClassOrTrait basicLocalSelectors.
	
	aBlock value: aClassOrTrait classSide methodDictionary.
	aBlock value: aClassOrTrait classSide organization.
	aBlock value: aClassOrTrait classSide traitComposition.
	aBlock value: aClassOrTrait classSide basicLocalSelectors.! !

!FLClassOrTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 23:37'!
serialize: aClassOrTrait with: aSerializer

	self serializeInstance: aClassOrTrait with: aSerializer.

	aSerializer referenceSerializingActionsAdd:
		[ self serializeReferencesOf: aClassOrTrait with: aSerializer ].

	aSerializer postReferenceSerializingActionsAdd:
		[ self serializePostReferencesOf: aClassOrTrait with: aSerializer ].
! !

!FLClassOrTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 22:17'!
serializeInstance: aClassOrTrait with: aSerializer

	self explicitRequirement ! !

!FLClassOrTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 23:48'!
serializePostReferencesOf: aClassOrTrait with: aSerializer

	aSerializer nextPutReferenceTo: aClassOrTrait traitComposition.
	aSerializer nextPutReferenceTo: aClassOrTrait classSide traitComposition.
! !

!FLClassOrTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 23:48'!
serializeReferencesOf: aClassOrTrait with: aSerializer

	aSerializer nextPutReferenceTo: aClassOrTrait methodDictionary.
	aSerializer nextPutReferenceTo: aClassOrTrait organization. 
	aSerializer nextPutReferenceTo: aClassOrTrait basicLocalSelectors.
	
	aSerializer nextPutReferenceTo: aClassOrTrait classSide methodDictionary.
	aSerializer nextPutReferenceTo: aClassOrTrait classSide organization.
	aSerializer nextPutReferenceTo: aClassOrTrait classSide basicLocalSelectors.! !

FLClassOrTraitCluster subclass: #FLTraitCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLTraitCluster commentStamp: 'MartinDias 5/30/2011 01:17' prior: 0!
I am a cluster for traits with full detail. The trait will be recreated completely on the materializing image.!

!FLTraitCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 3/24/2011 03:35'!
id
	^ 18! !

!FLTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/29/2011 23:40'!
materializeInstanceWith: aMaterializer

	| category name |
	category := aMaterializer stream nextString.
	name := aMaterializer stream nextString asSymbol.
	^Trait named: name uses: {} category: category.! !

!FLTraitCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/12/2011 10:32'!
serializeInstance: aTrait with: aSerializer

	aSerializer stream nextStringPut: aTrait basicCategory.
	aSerializer stream nextStringPut: aTrait name.! !

FLIteratingCluster subclass: #FLClassPoolAssociationCluster
	instanceVariableNames: 'ownerClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLClassPoolAssociationCluster commentStamp: 'MartinDias 5/30/2011 01:17' prior: 0!
I am a cluster for class variable associations, i.e. bindings that belong to the class pool of a Class included on Smalltalk globals.!

!FLClassPoolAssociationCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 10/18/2010 18:02'!
id

	^ 20! !

!FLClassPoolAssociationCluster classSide methodsFor: 'instance creation' stamp: 'MartinDias 10/18/2010 17:55'!
newFor: aClass

	^ self basicNew
		initialize;
		ownerClass: aClass;
		yourself.! !

!FLClassPoolAssociationCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/26/2011 17:04'!
materializeWith: aMaterializer

	| keyName |
	ownerClass := aMaterializer nextReferencedObject.
	keyName := aMaterializer stream nextString.
	^ ownerClass classPool associationAt: keyName asSymbol ! !

!FLClassPoolAssociationCluster methodsFor: 'accessing' stamp: 'MartinDias 10/18/2010 17:59'!
ownerClass: anObject
	ownerClass := anObject! !

!FLClassPoolAssociationCluster methodsFor: 'analyzing' stamp: 'MartinDias 11/11/2010 18:31'!
referencesOf: anAssociation do: aBlock

	aBlock value: ownerClass! !

!FLClassPoolAssociationCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/12/2011 10:32'!
serialize: anAssociation with: aSerializer

	aSerializer nextPutReferenceTo: ownerClass.
	aSerializer stream nextStringPut: anAssociation key! !

FLIteratingCluster subclass: #FLClassSideCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLClassSideCluster commentStamp: 'MartinDias 5/30/2011 01:17' prior: 0!
I am a cluster for Metaclasses and ClassTrait.!

!FLClassSideCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:24'!
id
	^ 12! !

!FLClassSideCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/24/2011 12:27'!
materializeWith: aMaterializer

	^ aMaterializer nextReferencedObject classSide! !

!FLClassSideCluster methodsFor: 'analyzing' stamp: 'MartinDias 3/23/2011 18:06'!
referencesOf: aClassOrTraitClassSide do: aBlock

	aBlock value: aClassOrTraitClassSide instanceSide! !

!FLClassSideCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/24/2011 12:27'!
serialize: aClassOrTraitClassSide with: aSerializer

	aSerializer nextPutReferenceTo: aClassOrTraitClassSide instanceSide! !

FLIteratingCluster subclass: #FLCompiledMethodCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLCompiledMethodCluster commentStamp: 'MartinDias 5/30/2011 01:17' prior: 0!
I am a cluster for CompiledMethod instances.!

!FLCompiledMethodCluster class methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:19'!
id
	^2! !

!FLCompiledMethodCluster methodsFor: 'protected' stamp: 'MartinDias 10/7/2010 00:36'!
materializeLiteralsTo: compiledMethod with: aMaterializer

	1 to: compiledMethod numLiterals 
		do: [ :index | compiledMethod literalAt: index put: aMaterializer nextReferencedObject ]
! !

!FLCompiledMethodCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/14/2011 19:46'!
materializeWith: aMaterializer

	| compiledMethod header bytecodesPlusTrailerSize aReadStream |

	aReadStream := aMaterializer stream.

	header := (aReadStream nextWord << 16) bitOr: aReadStream nextWord.
	bytecodesPlusTrailerSize := aReadStream nextWord.

	compiledMethod := CompiledMethod newMethod: bytecodesPlusTrailerSize header: header.

	compiledMethod initialPC to: compiledMethod size
		do: [ :index | compiledMethod at: index put: aReadStream next ].

	aMaterializer referenceMaterializingActionsAdd: 
		[ self materializeLiteralsTo: compiledMethod with: aMaterializer ].
		
	^ compiledMethod! !

!FLCompiledMethodCluster methodsFor: 'analyzing' stamp: 'MartinDias 3/26/2011 16:27'!
referencesOf: anObject do: aBlock

	1 to: anObject numLiterals
		do: [ :index | aBlock value: (anObject literalAt: index) ]! !

!FLCompiledMethodCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/14/2011 19:45'!
serialize: aCompiledMethod with: aSerializer

	| header aWriteStream bytecodesPlusTrailerSize cmSize cmInitialPC |

	aWriteStream := aSerializer stream.

	header := aCompiledMethod header.
	cmSize := aCompiledMethod size.
	cmInitialPC := aCompiledMethod initialPC.
	bytecodesPlusTrailerSize := cmSize - cmInitialPC + 1.

	aWriteStream 
		nextWordPut: (header >> 16);
		nextWordPut: header;
		nextWordPut: bytecodesPlusTrailerSize.

	cmInitialPC to: cmSize
		do: [ :index | aWriteStream nextPut: (aCompiledMethod at: index) ].

	aSerializer referenceSerializingActionsAdd: 
		[ self serializeLiteralsOf: aCompiledMethod with: aSerializer ]! !

!FLCompiledMethodCluster methodsFor: 'protected' stamp: 'MartinDias 10/7/2010 00:36'!
serializeLiteralsOf: aCompiledMethod with: aSerializer

	1 to: aCompiledMethod numLiterals 
		do: [ :index | aSerializer nextPutReferenceTo: (aCompiledMethod literalAt: index) ]! !

FLCompiledMethodCluster subclass: #FLNamedPrimitiveMethodCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLNamedPrimitiveMethodCluster commentStamp: 'MartinDias 5/30/2011 01:17' prior: 0!
I am a cluster for CompiledMethods which are <primitive:module:> primitives.

For example, Integer >> bitAnd: should be serialized with me.!

!FLNamedPrimitiveMethodCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 10/22/2010 12:08'!
id

	^ 23! !

!FLNamedPrimitiveMethodCluster methodsFor: 'protected' stamp: 'MarianoMartinezPeck 5/23/2011 11:17'!
materializeLiteralsTo: compiledMethod with: aMaterializer

	| module name |

	module := aMaterializer nextReferencedObject.
	name := aMaterializer nextReferencedObject.
	"The third element of the array is Obsolete. We can put whatever we want since it is not used anymore by the VM. It used to be a session ID. The forth element is the primitive index in a externalPrimitiveTable and it is IMPORTANT to put it in zero. Always. Otherwise there can be errors. Putting a zero means that the VM will not try to directly execute the primitive from the table and it will always try to load the module. It is the safer thing to do. For more details, read the method #primitiveExternalCall in VMMaker"
	compiledMethod literalAt: 1 put: (Array with: module with: name with: 0 with: 0).

	2 to: compiledMethod numLiterals 
		do: [ :index | compiledMethod literalAt: index put: aMaterializer nextReferencedObject ]
! !

!FLNamedPrimitiveMethodCluster methodsFor: 'analyzing' stamp: 'MartinDias 11/11/2010 18:31'!
referencesOf: anObject do: aBlock

	aBlock 
		value: (anObject literalAt: 1) first;
		value: (anObject literalAt: 1) second. 

	2 to: anObject numLiterals
		do: [ :index | aBlock value: (anObject literalAt: index) ]! !

!FLNamedPrimitiveMethodCluster methodsFor: 'protected' stamp: 'MartinDias 10/26/2010 14:43'!
serializeLiteralsOf: aCompiledMethod with: aSerializer

	| primitiveArguments |
	
	primitiveArguments := aCompiledMethod literalAt: 1.
	aSerializer 
		nextPutReferenceTo: primitiveArguments first;
		nextPutReferenceTo: primitiveArguments second.

	2 to: aCompiledMethod numLiterals 
		do: [ :index | aSerializer nextPutReferenceTo: (aCompiledMethod literalAt: index) ]! !

!FLIteratingCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 02:50'!
materializeAllWith: aMaterializer
	"Template method that let to the subclass the materialization using the received materializer"

	| instanceCount |
	instanceCount := aMaterializer nextIndex.

	instanceCount timesRepeat: 
		[ aMaterializer addMaterialized: 
			(self materializeWith: aMaterializer) ].! !

!FLIteratingCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:30'!
materializeWith: aMaterializer
	"Hook method that each subclass should customize for its special way of materializing"

	^ self subclassResponsibility! !

!FLIteratingCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/11/2010 18:02'!
serialize: anObject with: aSerializer
	"Hook method that each subclass should customize for its special way of serializing"

	self subclassResponsibility ! !

!FLIteratingCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 02:43'!
serializeAll: aCollection with: aSerializer
	"Template method that let to the subclass the serialization of each instance received"

	aSerializer nextPutIndex: aCollection size.
	aCollection do: [ :instance | self serialize: instance with: aSerializer ]! !

FLIteratingCluster subclass: #FLMethodContextCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLMethodContextCluster commentStamp: 'MartinDias 5/30/2011 01:18' prior: 0!
I am a cluster for MethodContexts.!

!FLMethodContextCluster class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/23/2011 00:10'!
id
	^99! !

!FLMethodContextCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/23/2011 00:31'!
materializeReferencesOf: materializedMethodContext with: aMaterializer
	
	materializedMethodContext pc: aMaterializer nextReferencedObject.
	materializedMethodContext method: aMaterializer nextReferencedObject.
	materializedMethodContext receiver: aMaterializer nextReferencedObject.
	materializedMethodContext privSender: aMaterializer nextReferencedObject.
	materializedMethodContext closure: aMaterializer nextReferencedObject.
	^ materializedMethodContext! !

!FLMethodContextCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/23/2011 00:31'!
materializeWith: aMaterializer

	|  materializedMethodContext frameSize |

	materializedMethodContext := MethodContext newFromFrameSize: (aMaterializer stream nextWord).
"	materializedMethodContext pc:  (aMaterializer stream nextWord).."
	materializedMethodContext stackp:  (aMaterializer stream nextWord)..
	
	aMaterializer referenceMaterializingActionsAdd: [
		self materializeReferencesOf: materializedMethodContext with: aMaterializer ].

	^ materializedMethodContext! !

!FLMethodContextCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/23/2011 00:30'!
referencesOf: aMethodContext do: aBlock

	aBlock value: aMethodContext pc.
	aBlock value: aMethodContext method.
	aBlock value: aMethodContext receiver.
	aBlock value: aMethodContext sender.
	aBlock value: aMethodContext closure.
	! !

!FLMethodContextCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/23/2011 00:31'!
serialize: aMethodContext with: aSerializer

	aSerializer stream nextWordPut: aMethodContext method frameSize.
"	aSerializer stream nextWordPut: aMethodContext pc."
	aSerializer stream nextWordPut: aMethodContext stackPtr.
	
	aSerializer referenceSerializingActionsAdd: [
		self serializeReferences: aMethodContext with: aSerializer ]! !

!FLMethodContextCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/23/2011 11:27'!
serializeReferences: aMethodContext with: aSerializer
	
	aSerializer nextPutReferenceTo: aMethodContext pc.
	aSerializer nextPutReferenceTo: aMethodContext method.
	aSerializer nextPutReferenceTo: aMethodContext receiver.
	aSerializer nextPutReferenceTo: aMethodContext sender.
	aSerializer nextPutReferenceTo: aMethodContext closure.
		! !

FLIteratingCluster subclass: #FLMethodDictionaryCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLMethodDictionaryCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 3/22/2011 01:08'!
id
	^ 96! !

!FLMethodDictionaryCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/22/2011 02:11'!
materializeKeysAndValuesTo: aDictionary with: aMaterializer size: size
	
	size timesRepeat: [
		| method |
		method := aMaterializer nextReferencedObject.
		aDictionary at: method selector put: method ]! !

!FLMethodDictionaryCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 02:50'!
materializeWith: aMaterializer
	
	| dictionary size |
	size := aMaterializer nextIndex.
	dictionary := MethodDictionary new: size.
	
	aMaterializer postReferenceMaterializingActionsAdd: [
		self materializeKeysAndValuesTo: dictionary with: aMaterializer size: size ].
	
	^ dictionary! !

!FLMethodDictionaryCluster methodsFor: 'analyzing' stamp: 'MartinDias 3/22/2011 02:06'!
referencesOf: aDictionary do: aBlock

	aDictionary do: [ :value | aBlock value: value ]! !

!FLMethodDictionaryCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 02:43'!
serialize: aDictionary with: aSerializer

	aSerializer nextPutIndex: aDictionary size.
	aSerializer postReferenceSerializingActionsAdd: [
		self serializeKeysAndValuesOf: aDictionary with: aSerializer ]! !

!FLMethodDictionaryCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 3/24/2011 12:57'!
serializeKeysAndValuesOf: aDictionary with: aSerializer

	aDictionary do: [ :value | aSerializer nextPutReferenceTo: value ]! !

FLCluster subclass: #FLObjectCluster
	uses: FLTWithClass
	instanceVariableNames: 'theClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLObjectCluster commentStamp: 'MartinDias 5/30/2011 01:24' prior: 0!
I implement a generic way of serializing and materializing an object, for those that do not need more special way of doing it.

For example,

	10@20 fuelCluster

returns an instance of a subclass of me.

!

FLObjectCluster class
	uses: FLTWithClass classTrait
	instanceVariableNames: ''!

FLObjectCluster subclass: #FLFixedObjectCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLFixedObjectCluster commentStamp: 'MartinDias 5/30/2011 01:25' prior: 0!
I am a generic cluster for objects without indexable variables.!

!FLFixedObjectCluster class methodsFor: 'accessing' stamp: 'MartinDias 5/26/2011 22:47'!
id

	^101! !

!FLFixedObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 03:42'!
materializeInstanceWith: aMaterializer

	^theClass basicNew! !

!FLFixedObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/27/2011 00:05'!
serializeInstance: anObject with: aSerializer

! !

!FLObjectCluster class methodsFor: 'instance creation' stamp: 'MartinDias 5/30/2011 03:42'!
for: aClass

	^ self basicNew
		theClass: aClass;
		yourself.! !

!FLObjectCluster methodsFor: 'analyzing' stamp: 'MartinDias 5/30/2011 03:45'!
clusterReferencesDo: aBlock

	aBlock value: theClass! !

!FLObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 03:42'!
materializeAllWith: aMaterializer
	"Template method that let to the subclass the materialization using the received materializer"

	| instances instanceCount aMapping |
	theClass := aMaterializer nextReferencedObject.
	aMapping := self materializeVariablesMappingWith: aMaterializer.  
	instanceCount := aMaterializer nextIndex.
	instances := OrderedCollection new: instanceCount.

	instanceCount timesRepeat: [ 
		instances add: (self materializeInstanceWith: aMaterializer) ].

	aMaterializer referenceMaterializingActionsAdd: [ self materializeReferencesOfAll: instances with: aMaterializer mapping: aMapping ].
	aMaterializer postReferenceMaterializingActionsAdd: [ self postMaterializeReferencesOfAll: instances with: aMaterializer ].
	aMaterializer addAllMaterialized: instances.! !

!FLObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/26/2011 23:40'!
materializeInstanceWith: aMaterializer

	self subclassResponsibility ! !

!FLObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/26/2011 23:58'!
materializeReferencesOf: anObject with: aMaterializer mapping: aMapping
	
	aMapping materializeReferencesOf: anObject with: aMaterializer! !

!FLObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 4/24/2011 17:44'!
materializeReferencesOfAll: instances with: aMaterializer mapping: aMapping
	
	instances do: [ :anObject | 
		self materializeReferencesOf: anObject with: aMaterializer mapping: aMapping ]! !

!FLObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 03:42'!
materializeVariablesMappingWith: aMaterializer

	| numberOfInstanceVariables instanceVariableNames |
	numberOfInstanceVariables := aMaterializer stream next.
	instanceVariableNames := (1 to: numberOfInstanceVariables) collect: [ :index | aMaterializer stream nextString ].

	^ FLVariablesMapping 
			actualClass: theClass
			originalInstanceVariableNames: instanceVariableNames.
! !

!FLObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/26/2011 22:33'!
postMaterializeReferencesOfAll: aCollection with: aMaterializer
! !

!FLObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/27/2011 00:13'!
postSerializeReferencesOfAll: anObject with: aSerializer! !

!FLObjectCluster methodsFor: 'printing' stamp: ''!
printOn: aStream
	"Append to the argument, aStream, a sequence of characters that  
	identifies the receiver."
	
	super printOn: aStream.
	aStream nextPut: $(.
	self parameterClass printOn: aStream.
	aStream nextPut: $).
	! !

!FLObjectCluster methodsFor: 'analyzing' stamp: 'MartinDias 5/30/2011 03:42'!
referencesOf: anObject do: aBlock

	1 to: theClass instSize 
		do: [ :index | aBlock value: (anObject instVarAt: index) ]! !

!FLObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 02:43'!
serializeAll: aCollection with: aSerializer
	"Template method that let to the subclass the serialization of each instance received"

	self serializeVariablesMappingWith: aSerializer.  
	aSerializer nextPutIndex: aCollection size.

	aCollection do: [ :instance | self serializeInstance: instance with: aSerializer. ].
	
	aSerializer referenceSerializingActionsAdd: [ self serializeReferencesOfAll: aCollection with: aSerializer ].
	aSerializer postReferenceSerializingActionsAdd: [ self postSerializeReferencesOfAll: aCollection with: aSerializer ].! !

!FLObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/27/2011 00:05'!
serializeInstance: anObject with: aSerializer

	self subclassResponsibility ! !

!FLObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 03:42'!
serializeReferencesOf: anObject with: aSerializer
	
	1 to: theClass instSize do: [ :index |
		aSerializer nextPutReferenceTo: (anObject instVarAt: index) ]
! !

!FLObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/27/2011 00:04'!
serializeReferencesOfAll: aCollection with: aSerializer
	
	aCollection do: [ :anObject | 
		self serializeReferencesOf: anObject with: aSerializer ]! !

!FLObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 03:42'!
serializeVariablesMappingWith: aSerializer  

	aSerializer nextPutReferenceTo: theClass.
	aSerializer stream nextPut: theClass instSize. 
	theClass instVarNamesAndOffsetsDo: [ :name :index | aSerializer stream nextStringPut: name ].! !

!FLObjectCluster methodsFor: 'accessing' stamp: 'MartinDias 5/30/2011 03:42'!
theClass

	^theClass ! !

!FLObjectCluster methodsFor: 'accessing' stamp: 'MartinDias 5/30/2011 03:43'!
theClass: aClass

	theClass := aClass ! !

FLObjectCluster subclass: #FLVariableObjectCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLVariableObjectCluster commentStamp: 'MartinDias 5/30/2011 01:25' prior: 0!
I am a generic cluster for objects with indexable variables.!

FLVariableObjectCluster subclass: #FLHashedCollectionCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLHashedCollectionCluster commentStamp: 'MartinDias 5/30/2011 01:26' prior: 0!
I am a cluster for instances of HashedCollection subclasses.!

!FLHashedCollectionCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 5/26/2011 22:47'!
id

	^ 105! !

!FLHashedCollectionCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/26/2011 22:41'!
postMaterializeReferencesOfAll: aCollection with: aMaterializer

	aCollection do: [ :aHashedCollection | aHashedCollection rehash ]! !

!FLVariableObjectCluster class methodsFor: 'accessing' stamp: 'MartinDias 5/26/2011 22:47'!
id

	^103! !

!FLVariableObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 03:42'!
materializeInstanceWith: aMaterializer

	^theClass basicNew: aMaterializer nextIndex! !

!FLVariableObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 4/21/2011 12:23'!
materializeReferencesOf: anObject with: aMaterializer mapping: mapping

	super materializeReferencesOf: anObject with: aMaterializer mapping: mapping.

	1 to: anObject basicSize 
		do: [ :index | anObject basicAt: index put: aMaterializer nextReferencedObject ]! !

!FLVariableObjectCluster methodsFor: 'analyzing' stamp: 'MartinDias 4/20/2011 00:35'!
referencesOf: anObject do: aBlock

	super referencesOf: anObject do: aBlock.

	1 to: anObject basicSize 
		do: [ :index | aBlock value: (anObject basicAt: index) ]! !

!FLVariableObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 02:43'!
serializeInstance: anObject with: aSerializer

	aSerializer nextPutIndex: anObject basicSize! !

!FLVariableObjectCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 4/20/2011 00:18'!
serializeReferencesOf: anObject with: aSerializer

	super serializeReferencesOf: anObject with: aSerializer.
	
	1 to: anObject basicSize do: [ :index |
		aSerializer nextPutReferenceTo: (anObject basicAt: index) ]! !

FLCluster subclass: #FLPrimitiveCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLPrimitiveCluster commentStamp: 'MartinDias 5/30/2011 01:27' prior: 0!
I am a template class whose algorithm for serialize a collection of objects is to delegate the serialization of each individual object to the subclass. 

(TODO) My main difference with FLIteratingCluster is that my method hooks only receive a stream and not the complete instance of FLSerializer, because they have not need. But possibly there is no reason for being different classes.!

FLPrimitiveCluster subclass: #FLByteArrayCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLByteArrayCluster commentStamp: 'MartinDias 5/30/2011 01:27' prior: 0!
I am a cluster for ByteArray.!

!FLByteArrayCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 10/25/2010 14:37'!
id

	^25! !

!FLByteArrayCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/12/2011 10:38'!
materializeFrom: aReadStream

	^ aReadStream next: (aReadStream nextNumber: 4) ! !

!FLByteArrayCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/12/2011 10:39'!
serialize: aByteArray on: aWriteStream

	aWriteStream nextNumber: 4 put: aByteArray size.
	aWriteStream nextPutAll: aByteArray.
! !

FLPrimitiveCluster subclass: #FLByteStringCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLByteStringCluster commentStamp: 'MartinDias 5/30/2011 01:27' prior: 0!
I am a cluster for ByteString.!

!FLByteStringCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 10/25/2010 13:32'!
id

	^24! !

!FLByteStringCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/25/2010 13:38'!
materializeFrom: aReadStream

	^ aReadStream nextString! !

!FLByteStringCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/25/2010 13:38'!
serialize: aString on: aWriteStream

	aWriteStream nextStringPut: aString! !

FLPrimitiveCluster subclass: #FLCharacterCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLCharacterCluster commentStamp: 'MartinDias 5/30/2011 01:27' prior: 0!
I am a cluster for Character.!

!FLCharacterCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:24'!
id

	^1! !

!FLCharacterCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 11:06'!
materializeFrom: aReadStream

	^Character value: aReadStream next! !

!FLCharacterCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 11/22/2010 17:33'!
serialize: aCharacter on: aWriteStream

	aWriteStream nextPut: aCharacter codePoint! !

FLPrimitiveCluster subclass: #FLFloatCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLFloatCluster commentStamp: 'MartinDias 5/30/2011 01:27' prior: 0!
I am a cluster for 8-byte Floats. 

Implementation extracted from ReferenceStream.
!

!FLFloatCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 10/20/2010 22:45'!
id
	^21! !

!FLFloatCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/21/2010 13:27'!
materializeFrom: aReadStream

	^ (Float new: 2)
		at: 1 put: (aReadStream nextNumber: 4);
		at: 2 put: (aReadStream nextNumber: 4);
		yourself.
! !

!FLFloatCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/21/2010 10:39'!
serialize: aFloat on: aWriteStream

	aWriteStream 
		nextNumber: 4 put: (aFloat at: 1);
		nextNumber: 4 put: (aFloat at: 2).! !

FLPrimitiveCluster subclass: #FLGlobalAssociationCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLGlobalAssociationCluster commentStamp: 'MartinDias 5/30/2011 01:28' prior: 0!
I am a cluster for variable bindings that belong to Smalltalk global dictionary.

For example, 

	Smalltalk globals associationAt: #Transcript 
	
could be serialized and materialized by me.!

!FLGlobalAssociationCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 10/18/2010 12:16'!
id
	^ 19! !

!FLGlobalAssociationCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/19/2010 15:08'!
materializeFrom: aReadStream

	^ Smalltalk globals 
		associationAt: aReadStream nextString asSymbol
		ifAbsent: [ self error: 'Association not found.' ] ! !

!FLGlobalAssociationCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/18/2010 12:10'!
serialize: anAssociation on: aWriteStream
	
	aWriteStream nextStringPut: anAssociation key! !

FLPrimitiveCluster subclass: #FLGlobalCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLGlobalCluster commentStamp: 'MartinDias 5/30/2011 01:28' prior: 0!
I am a cluster for known objects that belong to Smalltalk global dictionary.

For example, Transcript could be serialized and materialized by me.!

!FLGlobalCluster class methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:25'!
id
	^ 11! !

!FLGlobalCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/19/2010 14:52'!
materializeFrom: aReadStream

	^ Smalltalk globals 
		at: aReadStream nextString asSymbol 
		ifAbsent: [ self error: 'Smalltalk global not found' ]! !

!FLGlobalCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/12/2011 10:13'!
serialize: anObject on: aWriteStream
	
	aWriteStream 
		nextStringPut: (Smalltalk globals keyAtValue: anObject).! !

FLPrimitiveCluster subclass: #FLLargeNegativeIntegerCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLLargeNegativeIntegerCluster commentStamp: 'MartinDias 5/30/2011 01:28' prior: 0!
I am a cluster for LargeNegativeInteger.!

!FLLargeNegativeIntegerCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:25'!
id
	^8! !

!FLLargeNegativeIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 21:39'!
materializeFrom: aReadStream

	| size value |
	size := aReadStream next.
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: aReadStream next].
	^ value negated ! !

!FLLargeNegativeIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 10:44'!
serialize: anInteger on: aWriteStream

	| size byte positive |
	positive := anInteger abs.
	size := (positive log: 256) floor + 1.
	aWriteStream nextPut:size.
	(size - 1 to: 0 by: -1) do:
		[:index |
			byte := (positive bitShift: index * -8) bitAnd: 255.
			aWriteStream nextPut: byte]! !

FLPrimitiveCluster subclass: #FLLargePositiveIntegerCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLLargePositiveIntegerCluster commentStamp: 'MartinDias 5/30/2011 01:28' prior: 0!
I am a cluster for LargePositiveInteger.!

!FLLargePositiveIntegerCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:25'!
id
	^7! !

!FLLargePositiveIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 21:39'!
materializeFrom: aReadStream

	| size value |
	size:=aReadStream next.
	value := 0.
	size timesRepeat: [value := (value bitShift: 8) bitOr: aReadStream next].
	^ value! !

!FLLargePositiveIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 9/27/2010 13:42'!
serialize: anInteger on: aWriteStream

	| size byte |
	size:=(anInteger log: 256) floor + 1.
	aWriteStream nextPut: size.
	(size - 1 to: 0 by: -1) do:
		[:index |
		byte := (anInteger bitShift: index * -8) bitAnd: 255.
		aWriteStream nextPut: byte]! !

FLPrimitiveCluster subclass: #FLNilTrueFalseCluster
	instanceVariableNames: ''
	classVariableNames: 'WellKnownObjectsDictionary'
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLNilTrueFalseCluster commentStamp: 'MartinDias 5/30/2011 01:28' prior: 0!
I am a cluster for nil, true and false. They have a special treatment because they are so common in the image.!

!FLNilTrueFalseCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 10/19/2010 12:20'!
id

	^4! !

!FLNilTrueFalseCluster classSide methodsFor: 'class initialization' stamp: 'MartinDias 5/13/2011 10:24'!
initialize 

	WellKnownObjectsDictionary := Dictionary new
		add: 1 -> nil;
		add: 2 -> true;
		add: 3 -> false;
		yourself.! !

!FLNilTrueFalseCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/19/2010 12:21'!
materializeFrom: aReadStream
	
	^ WellKnownObjectsDictionary at: aReadStream next
	! !

!FLNilTrueFalseCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/19/2010 13:30'!
serialize: aWellKnownObject on: aWriteStream

	aWriteStream nextPut: (WellKnownObjectsDictionary keyAtValue: aWellKnownObject)! !

!FLPrimitiveCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 02:50'!
materializeAllWith: aMaterializer 
	"Template method that let to the subclass the materialization using the received materializer"
	
	| instanceCount |
	instanceCount := aMaterializer nextIndex.

	instanceCount timesRepeat: 
		[ aMaterializer addMaterialized: 
			(self materializeFrom: aMaterializer stream) ].! !

!FLPrimitiveCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:30'!
materializeFrom: aReadStream
	"Hook method that each subclass should customize for its special way of materializing"
	
	self subclassResponsibility ! !

!FLPrimitiveCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/13/2010 13:29'!
serialize: anObject on: aWriteStream
	"Hook method that each subclass should customize for its special way of serializing"
	
	self subclassResponsibility! !

!FLPrimitiveCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 02:43'!
serializeAll: aCollection with: aSerializer
	"Template method that let to the subclass the serialization of each instance received"
	
	aSerializer nextPutIndex: aCollection size.
	aCollection do: [ :instance | self serialize: instance on: aSerializer stream ]! !

FLPrimitiveCluster subclass: #FLReferencedClassCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLReferencedClassCluster commentStamp: 'MartinDias 5/30/2011 01:28' prior: 0!
I am a cluster for classes that should be present when materializing. In other words, it only serializes a reference to the class, using its name.!

!FLReferencedClassCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 11/11/2010 21:01'!
id
	^ 81! !

!FLReferencedClassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 03:48'!
materializeFrom: aReadStream
	| className |
	className := aReadStream nextString asSymbol .
	^ Smalltalk globals 
		at: className
		ifAbsent: [ FLClassNotFound new signal: 'Class', className, ' not found at materialization' ]! !

!FLReferencedClassCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/12/2011 10:32'!
serialize: aClass on: aWriteStream
	
	aWriteStream nextStringPut: aClass name ! !

FLPrimitiveCluster subclass: #FLSmallIntegerCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLSmallIntegerCluster commentStamp: '<historical>' prior: 0!
I don't have so much sense as a class, but I know which of my subclasses corresponds to each SmallInteger.!

FLSmallIntegerCluster subclass: #FLNegativeSmallIntegerCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLNegativeSmallIntegerCluster commentStamp: 'MartinDias 5/30/2011 01:29' prior: 0!
I am a cluster for negative SmallInteger instances.!

!FLNegativeSmallIntegerCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:26'!
id
	^10! !

!FLNegativeSmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 21:39'!
materializeFrom: aReadStream

	| hi mid1 mid2 lo |
	hi := aReadStream next.
	mid2 := aReadStream next.
	mid1 := aReadStream next.
	lo := aReadStream next.
	^ ((hi bitShift: 24) + (mid2 bitShift: 16) + (mid1 bitShift: 8) + lo) negated! !

!FLNegativeSmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/12/2010 10:38'!
serialize: anInteger on: aWriteStream

	| aPositiveInteger |
	aPositiveInteger := anInteger abs.
	aWriteStream nextPut: (aPositiveInteger bitShift: -24).
	aWriteStream nextPut: ((aPositiveInteger bitShift: -16) bitAnd: 255).
	aWriteStream nextPut: ((aPositiveInteger bitShift: -8) bitAnd: 255).
	aWriteStream nextPut: (aPositiveInteger bitAnd: 255).! !

FLSmallIntegerCluster subclass: #FLPositiveSmallIntegerCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLPositiveSmallIntegerCluster commentStamp: 'MartinDias 5/30/2011 01:29' prior: 0!
I am a cluster for positive SmallInteger instances.!

!FLPositiveSmallIntegerCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:26'!
id
	^9! !

!FLPositiveSmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/15/2010 10:51'!
materializeFrom: aReadStream

	| hi mid1 mid2 lo |
	hi := aReadStream next.
	mid2 := aReadStream next.
	mid1 := aReadStream next.
	lo := aReadStream next.
	^ (((hi bitShift: 24) bitXor: (mid2 bitShift: 16)) bitXor: (mid1 bitShift: 8)) bitXor: lo! !

!FLPositiveSmallIntegerCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 9/24/2010 00:48'!
serialize: anInteger on: aWriteStream

	aWriteStream nextPut: (anInteger bitShift: -24).
	aWriteStream nextPut: ((anInteger bitShift: -16) bitAnd: 255).
	aWriteStream nextPut: ((anInteger bitShift: -8) bitAnd: 255).
	aWriteStream nextPut: (anInteger bitAnd: 255).! !

!FLSmallIntegerCluster class methodsFor: 'instance creation' stamp: 'MartinDias 5/30/2011 01:35'!
for: anSmallInteger
	"Returns the right subclass instance"

	((anSmallInteger bitAnd: 16rFFFF) = anSmallInteger)
		ifTrue: [ ^ FLUInt16Cluster instance ].

	anSmallInteger > 0 
		ifTrue: [ ^ FLPositiveSmallIntegerCluster instance ]
		ifFalse: [ ^ FLNegativeSmallIntegerCluster instance ]! !

FLSmallIntegerCluster subclass: #FLUInt16Cluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLUInt16Cluster commentStamp: 'MartinDias 5/30/2011 01:29' prior: 0!
I am a cluster for SmallInteger instances between 0 and 16rFFFF.!

!FLUInt16Cluster classSide methodsFor: 'accessing' stamp: 'MartinDias 12/22/2010 12:21'!
id
	^90! !

!FLUInt16Cluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/22/2010 12:20'!
materializeFrom: aReadStream

	| hi lo |
	hi := aReadStream next.
	lo := aReadStream next.
	^ (hi bitShift: 8) bitXor: lo! !

!FLUInt16Cluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/22/2010 13:16'!
serialize: anInteger on: aWriteStream

	aWriteStream nextPut: (anInteger bitShift: -8).
	aWriteStream nextPut: (anInteger bitAnd: 255).! !

FLPrimitiveCluster subclass: #FLSymbolCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLSymbolCluster commentStamp: 'MartinDias 5/30/2011 01:29' prior: 0!
I am a cluster for Symbol instances.!

!FLSymbolCluster classSide methodsFor: 'accessing' stamp: 'MartinDias 10/12/2010 13:26'!
id

	^3! !

!FLSymbolCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 10/26/2010 14:22'!
materializeFrom: aReadStream

	^ aReadStream nextString asSymbol! !

!FLSymbolCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/12/2011 10:13'!
serialize: aSymbol on: aWriteStream

	aWriteStream nextStringPut: aSymbol! !

FLCluster subclass: #FLRawArrayedCollectionCluster
	uses: FLTWithClass
	instanceVariableNames: 'theClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLRawArrayedCollectionCluster commentStamp: 'MartinDias 5/30/2011 01:29' prior: 0!
I am a cluster for ArrayedCollections subclasses that are raw bits and word-like. 

I use the ArrayedCollection messages #writeOn: and #newFromStream: for serialize and materialize instances.!

FLRawArrayedCollectionCluster class
	uses: FLTWithClass classTrait
	instanceVariableNames: ''!

!FLRawArrayedCollectionCluster classSide methodsFor: 'instance creation' stamp: 'MartinDias 4/19/2011 12:47'!
id

	^ 60! !

!FLRawArrayedCollectionCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 02:50'!
materializeAllWith: aMaterializer

	| arrayedCollectionClass numberOfCollections |
	arrayedCollectionClass := aMaterializer nextReferencedObject.
	numberOfCollections := aMaterializer nextIndex.
	numberOfCollections timesRepeat: [ 
		aMaterializer addMaterialized: (arrayedCollectionClass newFromStream: aMaterializer stream) ]! !

!FLRawArrayedCollectionCluster methodsFor: 'analyzing' stamp: 'MartinDias 5/30/2011 03:37'!
referencesOf: anArrayedCollection do: aBlock
	"Evaluates the received block with each object referenced by anObject"
	
	aBlock value: theClass  ! !

!FLRawArrayedCollectionCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 5/30/2011 03:37'!
serializeAll: arrayedCollections with: aSerializer

	aSerializer nextPutReferenceTo: theClass.
	aSerializer nextPutIndex: arrayedCollections size.
	arrayedCollections do: [ :anArrayedCollection |
		anArrayedCollection writeOn: aSerializer stream ]! !

!FLRawArrayedCollectionCluster methodsFor: 'accessing' stamp: 'MartinDias 5/30/2011 03:37'!
theClass

	^theClass! !

!FLRawArrayedCollectionCluster methodsFor: 'accessing' stamp: 'MartinDias 5/30/2011 03:37'!
theClass: aClass

	theClass := aClass ! !

Object subclass: #FLMapper
	instanceVariableNames: 'analyzer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Mappers'!

!FLMapper commentStamp: 'MartinDias 5/30/2011 01:14' prior: 0!
The purpose of my hierarchy is to map a objects with clusters. For doing that, I collaborate with FLAnalyzer.!

FLMapper subclass: #FLClassPoolAssociationMapper
	instanceVariableNames: 'internalClasses'
	classVariableNames: 'ClassPoolBindings'
	poolDictionaries: ''
	category: 'Fuel-Core-Mappers'!

!FLClassPoolAssociationMapper commentStamp: 'MartinDias 5/30/2011 01:14' prior: 0!
I map variable class variable associations, i.e. bindings that belong to the class pool of a Class existent on Smalltalk globals. !

!FLClassPoolAssociationMapper classSide methodsFor: 'class initialization' stamp: 'MartinDias 3/27/2011 06:55'!
classAdded: anEvent

	anEvent item classPool associationsDo: [ :aBinding | 
			ClassPoolBindings at: aBinding put: anEvent item ]


! !

!FLClassPoolAssociationMapper classSide methodsFor: 'class initialization' stamp: 'MartinDias 3/27/2011 06:55'!
classModified: anEvent
	"Refresh bindings dictionary when the class variables are modified."

	anEvent item isBehavior ifFalse: [ ^self ].
	anEvent areClassVarsModified ifFalse: [ ^self ].
	anEvent oldItem classPool associationsDo: [ :aBinding | 
			ClassPoolBindings removeKey: aBinding ifAbsent: [] ].
	anEvent item classPool associationsDo: [ :aBinding | 
			ClassPoolBindings at: aBinding put: anEvent item ].
! !

!FLClassPoolAssociationMapper classSide methodsFor: 'class initialization' stamp: 'MartinDias 3/27/2011 06:54'!
classRemoved: anEvent

	anEvent item classPool associationsDo: [ :association | 
		ClassPoolBindings
			removeKey: association
			ifAbsent: []]! !

!FLClassPoolAssociationMapper classSide methodsFor: 'class initialization' stamp: 'MartinDias 5/13/2011 10:23'!
initialize

	self initializeClassPoolBindings.
	self initializeListeners.
! !

!FLClassPoolAssociationMapper classSide methodsFor: 'class initialization' stamp: 'MartinDias 2/26/2011 03:07'!
initializeClassPoolBindings
	ClassPoolBindings := Dictionary new.
	Smalltalk allClassesAndTraitsDo: [ :aClass | 
		aClass classPool associationsDo: [ :aBinding | 
			ClassPoolBindings at: aBinding put: aClass ] ].
	ClassPoolBindings! !

!FLClassPoolAssociationMapper classSide methodsFor: 'class initialization' stamp: 'MartinDias 3/26/2011 16:39'!
initializeListeners

	self flag: #todo. "also unregistrer? another better way of doing this?"

	SystemChangeNotifier uniqueInstance 
		notify: self
			ofSystemChangesOfItem: #class
			change: #Removed
			using: #classRemoved:;
		notify: self
			ofSystemChangesOfItem: #class
			change: #Added
			using: #classAdded:;
		notify: self
			ofSystemChangesOfItem: #class
			change: #Modified
			using: #classModified:! !

!FLClassPoolAssociationMapper methodsFor: 'accessing' stamp: 'MartinDias 5/30/2011 02:01'!
accepts: anObject
	^ anObject isVariableBinding and: [ (self isClassVariableBinding: anObject) and: [ self isExternal: anObject ] ]! !

!FLClassPoolAssociationMapper methodsFor: 'initialize-release' stamp: 'MartinDias 5/20/2011 03:56'!
initialize

	super initialize.
	internalClasses := OrderedCollection new.! !

!FLClassPoolAssociationMapper methodsFor: 'accessing' stamp: 'MartinDias 5/20/2011 04:51'!
internalClasses: internalGlobalObjects

	internalClasses := internalGlobalObjects select: [ :anObject | anObject isBehavior ]! !

!FLClassPoolAssociationMapper methodsFor: 'accessing' stamp: 'MartinDias 3/27/2011 13:21'!
isClassVariableBinding: anObject
	^ ClassPoolBindings includesKey: anObject! !

!FLClassPoolAssociationMapper methodsFor: 'accessing' stamp: 'MartinDias 5/20/2011 03:56'!
isExternal: anObject
	^ (internalClasses includes: (ClassPoolBindings at: anObject)) not! !

!FLClassPoolAssociationMapper methodsFor: 'evaluating' stamp: 'MartinDias 5/30/2011 03:18'!
map: anObject

	| ownerClass |
	ownerClass  := ClassPoolBindings at: anObject.
	
	analyzer 
		map: anObject  
		to: (FLClassPoolAssociationCluster newFor: ownerClass)
		into: analyzer clustersWithBaselevelObjects! !

FLMapper subclass: #FLDefaultMapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Mappers'!

!FLDefaultMapper commentStamp: 'MartinDias 5/30/2011 01:14' prior: 0!
I map objects using the serializer specified by each's #fuelSerializer message. 

I use the visitor pattern because I'm quite coupled to each serializer implementation. (TODO) Maybe this design must be changed.

Any object could be analyzed by me.!

!FLDefaultMapper methodsFor: 'accessing' stamp: 'MartinDias 5/30/2011 02:01'!
accepts: anObject

	^ true! !

!FLDefaultMapper methodsFor: 'visiting' stamp: 'MartinDias 5/26/2011 17:33'!
classAndTraitCollection
	"Returns the proper collection for collecting classes and traits. Superclasses should be before of the subclasses."

	self flag: #todo. "not nice"
	^ SortedCollection sortBlock: [ :a :b | a printCompactHierarchy <= b printCompactHierarchy ]! !

!FLDefaultMapper methodsFor: 'evaluating' stamp: 'MartinDias 5/30/2011 02:04'!
map: anObject

	anObject fuelAccept: self! !

!FLDefaultMapper methodsFor: 'visiting' stamp: 'MartinDias 5/30/2011 03:18'!
visitClassOrTrait: aClassOrTrait
	"Visits a Class or a Trait that should be fully serialized."

	analyzer
		map: aClassOrTrait
		to: aClassOrTrait fuelCluster
		into: analyzer clustersWithInternalMetalevelObjects
		blockForNewCollection: [ self classAndTraitCollection ]! !

!FLDefaultMapper methodsFor: 'visiting' stamp: 'MartinDias 5/30/2011 03:18'!
visitMetaclass: aMetaclass

	analyzer  
		map: aMetaclass
		to: aMetaclass fuelCluster 
		into: analyzer clustersWithBaselevelObjects ! !

!FLDefaultMapper methodsFor: 'visiting' stamp: 'MartinDias 5/30/2011 03:18'!
visitNilTrueFalse: anObject
	"Visits these singleton objects. They has a special treatment because they are so common. And also nil is special because it cannot be added to a Set like the other objects."

	analyzer 
		map: anObject 
		to: anObject fuelCluster 
		into: analyzer clustersWithBaselevelObjects 
		blockForNewCollection: [ OrderedCollection new ]! !

!FLDefaultMapper methodsFor: 'visiting' stamp: 'MartinDias 5/30/2011 03:18'!
visitObject: anObject
	"Visits an object in the most generic way"

	analyzer
		map: anObject
		to: anObject fuelCluster
		into: analyzer clustersWithBaselevelObjects! !

FLMapper subclass: #FLGlobalAssociationMapper
	instanceVariableNames: 'internalAssociations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Mappers'!

!FLGlobalAssociationMapper commentStamp: 'MartinDias 5/30/2011 01:15' prior: 0!
I map variable bindings that belong to Smalltalk global dictionary.

For example, 

	Smalltalk globals associationAt: #Transcript 
	
is mapped by me.!

!FLGlobalAssociationMapper methodsFor: 'accessing' stamp: 'MartinDias 5/30/2011 02:01'!
accepts: anObject

	^ anObject isVariableBinding and: [(self isGlobalAssociation: anObject) and: [ self isExternalAssociation: anObject ]].
! !

!FLGlobalAssociationMapper methodsFor: 'initialize-release' stamp: 'MartinDias 5/20/2011 04:20'!
initialize

	super initialize.
	internalAssociations := OrderedCollection new.! !

!FLGlobalAssociationMapper methodsFor: 'accessing' stamp: 'MartinDias 5/20/2011 04:18'!
internalGlobals: aCollection

	internalAssociations := aCollection collect: [:aGlobal | Smalltalk globals associationAt: aGlobal name ]! !

!FLGlobalAssociationMapper methodsFor: 'accessing' stamp: 'MartinDias 5/20/2011 04:10'!
isExternalAssociation: anObject

	^ (internalAssociations includes: anObject ) not! !

!FLGlobalAssociationMapper methodsFor: 'accessing' stamp: 'MartinDias 5/20/2011 04:13'!
isGlobalAssociation: anObject

	^ Smalltalk globals includesAssociation: anObject! !

!FLGlobalAssociationMapper methodsFor: 'evaluating' stamp: 'MartinDias 5/30/2011 03:18'!
map: anObject

	analyzer 
		map: anObject  
		to: FLGlobalAssociationCluster instance
		into: analyzer clustersWithBaselevelObjects! !

FLMapper subclass: #FLGlobalMapper
	instanceVariableNames: 'internalGlobals'
	classVariableNames: 'GlobalBehaviors GlobalObjects'
	poolDictionaries: ''
	category: 'Fuel-Core-Mappers'!

!FLGlobalMapper commentStamp: 'MartinDias 5/30/2011 01:15' prior: 0!
I map classes and well known objects that belong to Smalltalk global dictionary.

For example, Transcript is mapped by me.!

!FLGlobalMapper classSide methodsFor: 'class initialization' stamp: 'MarianoMartinezPeck 12/2/2010 15:44'!
classAdded: anEvent

	GlobalObjects add: anEvent item

! !

!FLGlobalMapper classSide methodsFor: 'class initialization' stamp: 'MarianoMartinezPeck 12/2/2010 15:31'!
classRemoved: anEvent

	GlobalObjects 
		remove: anEvent item
		ifAbsent: [ ]! !

!FLGlobalMapper classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/21/2011 23:26'!
globalBehaviors

	^ GlobalBehaviors! !

!FLGlobalMapper classSide methodsFor: 'accessing' stamp: 'MartinDias 11/25/2010 16:16'!
globalNames

	^ #(#Display #World #Smalltalk #Transcript #SourceFiles #Processor #ImageImports #TextConstants #Undeclared #SystemOrganization #Sensor #ActiveWorld)! !

!FLGlobalMapper classSide methodsFor: 'accessing' stamp: 'MartinDias 11/25/2010 16:00'!
globalObjects

	^ GlobalObjects! !

!FLGlobalMapper classSide methodsFor: 'class initialization' stamp: 'MartinDias 11/25/2010 16:17'!
initialize

	super initialize.
	self initializeGlobalObjects.
	self initializeListeners.
! !

!FLGlobalMapper classSide methodsFor: 'class initialization' stamp: 'MarianoMartinezPeck 5/21/2011 23:43'!
initializeGlobalObjects
	GlobalBehaviors := (Smalltalk allClassesAndTraits asIdentitySet).
	GlobalObjects := (self globalNames collect: [ :key | Smalltalk globals at: key ]) asIdentitySet 
		! !

!FLGlobalMapper classSide methodsFor: 'class initialization' stamp: 'MartinDias 11/25/2010 16:30'!
initializeListeners

	self flag: #todo. "unregistrer? anocher better way of doing this?"

	SystemChangeNotifier uniqueInstance 
		notify: self
			ofSystemChangesOfItem: #class
			change: #Removed
			using: #classRemoved:;
		notify: self
			ofSystemChangesOfItem: #class
			change: #Added
			using: #classAdded:! !

!FLGlobalMapper methodsFor: 'accessing' stamp: 'MartinDias 5/30/2011 02:01'!
accepts: anObject

	^ ( ((self isGlobalObject: anObject) or: [self isGlobalBehavior: anObject] ) and: [self isExternal: anObject ])
		! !

!FLGlobalMapper methodsFor: 'initialize-release' stamp: 'MartinDias 5/20/2011 04:19'!
initialize

	super initialize.
	internalGlobals := OrderedCollection new.! !

!FLGlobalMapper methodsFor: 'accessing' stamp: 'MartinDias 5/20/2011 03:59'!
internalGlobals: anObject
	internalGlobals := anObject! !

!FLGlobalMapper methodsFor: 'accessing' stamp: 'MartinDias 5/20/2011 04:02'!
isExternal: anObject

	^ (internalGlobals includes: anObject) not! !

!FLGlobalMapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/21/2011 23:37'!
isGlobalBehavior: anObject
	(anObject isBehavior or: [anObject isTrait ])
		ifTrue: [^ self class globalBehaviors includes: anObject ]
		ifFalse: [ ^ false]
	! !

!FLGlobalMapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/21/2011 23:36'!
isGlobalObject: anObject

	^ self class globalObjects includes: anObject ! !

!FLGlobalMapper methodsFor: 'evaluating' stamp: 'MartinDias 5/30/2011 02:04'!
map: anObject

	anObject fuelAccept: self! !

!FLGlobalMapper methodsFor: 'visiting' stamp: 'MartinDias 5/30/2011 03:18'!
visitClassOrTrait: aClassOrTrait

	analyzer  
		map: aClassOrTrait 
		to: FLReferencedClassCluster instance
		into: analyzer clustersWithExternalMetalevelObjects ! !

!FLGlobalMapper methodsFor: 'visiting' stamp: 'MartinDias 5/30/2011 03:18'!
visitObject: anObject

	analyzer 
		map: anObject  
		to: FLGlobalCluster instance
		into: analyzer clustersWithExternalMetalevelObjects! !

!FLMapper class methodsFor: 'instance creation' stamp: 'MartinDias 10/20/2010 15:46'!
newWith: anAnalyzer

	^ self basicNew
		initialize;
		analyzer: anAnalyzer;
		yourself! !

!FLMapper methodsFor: 'accessing' stamp: 'MartinDias 5/30/2011 02:01'!
accepts: anObject
	"Tells if the received object is handled by this analyzer"

	self subclassResponsibility ! !

!FLMapper methodsFor: 'accessing' stamp: 'MartinDias 10/20/2010 15:42'!
analyzer
	^ analyzer! !

!FLMapper methodsFor: 'accessing' stamp: 'MartinDias 10/20/2010 15:42'!
analyzer: anObject
	analyzer := anObject! !

!FLMapper methodsFor: 'evaluating' stamp: 'MartinDias 5/30/2011 02:06'!
map: anObject
	"Maps anObject to the adequate cluster, using the analyzer"

	self subclassResponsibility ! !

Object subclass: #FLMaterializer
	instanceVariableNames: 'stream referenceMaterializingActions materializedInstances materializedRoot clusterCount postReferenceMaterializingActions indexCluster'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLMaterializer commentStamp: '<historical>' prior: 0!
I am a binary object materializer. 

By sending me #materialize, I will recreate previously serialized objects by FLSerializer from a byte stream. The results are obtained sending #materializedRoots.

!

!FLMaterializer class methodsFor: 'materializing' stamp: 'MarianoMartinezPeck 5/27/2011 11:04'!
materializeFromByteArray: byteArray
  	| materializer stream |
	stream := byteArray readStream.
    	materializer := self on: stream.
    	materializer materialize.
    	stream close.
    	^ materializer root
! !

!FLMaterializer class methodsFor: 'materializing' stamp: 'MarianoMartinezPeck 5/23/2011 23:07'!
materializeFromFileNamed: aFilename
  	| materializer aFileStream |
    	aFileStream := (StandardFileStream fileNamed: aFilename) binary.
    	materializer := self on: aFileStream.
    	materializer materialize.
    	aFileStream close.
    	^ materializer root
! !

!FLMaterializer class methodsFor: 'instance creation' stamp: 'MartinDias 9/20/2010 20:34'!
on: aReadStream

	^self new
		stream: aReadStream; 
		yourself
! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/13/2010 11:31'!
addAllMaterialized: aCollection
	
	materializedInstances addAll: aCollection ! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/13/2010 11:24'!
addMaterialized: anObject
	
	materializedInstances add: anObject ! !

!FLMaterializer methodsFor: 'initialize-release' stamp: 'MartinDias 3/20/2011 22:20'!
initialize 
	
	super initialize.
	referenceMaterializingActions := OrderedCollection new.
	postReferenceMaterializingActions := OrderedCollection new.! !

!FLMaterializer methodsFor: 'materializing' stamp: 'MartinDias 11/25/2010 19:14'!
materialize

	self materializeHeader.
	self materializeInstances.
	self materializeReferences.
	self materializeRoot.! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 5/30/2011 02:51'!
materializeHeader

	indexCluster := self nextCluster.
	materializedInstances := OrderedCollection new: self nextIndex.
	clusterCount := self nextIndex.
! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 5/30/2011 02:26'!
materializeInstances

	clusterCount timesRepeat: [ 
		self nextCluster materializeAllWith: self ].
! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 3/20/2011 22:20'!
materializeReferences

	referenceMaterializingActions
		do: [ :aBlock | aBlock value ].
	postReferenceMaterializingActions
		do: [ :aBlock | aBlock value ]
! !

!FLMaterializer methodsFor: 'private' stamp: 'MartinDias 10/28/2010 10:39'!
materializeRoot

	materializedRoot := self nextReferencedObject! !

!FLMaterializer methodsFor: 'decoding' stamp: 'MartinDias 5/30/2011 02:33'!
nextCluster

	^ FLCluster forId: stream next! !

!FLMaterializer methodsFor: 'decoding' stamp: 'MartinDias 5/30/2011 02:51'!
nextIndex
	^ indexCluster materializeFrom: stream! !

!FLMaterializer methodsFor: 'decoding' stamp: 'MartinDias 5/30/2011 02:51'!
nextReferencedObject 

	^ materializedInstances at: 
		(indexCluster materializeFrom: stream)! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 3/20/2011 22:19'!
postReferenceMaterializingActionsAdd: aBlock
	"Adds an action for being valued at the references materializing step"
	
	postReferenceMaterializingActions add: aBlock ! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/15/2010 10:47'!
referenceMaterializingActionsAdd: aBlock
	"Adds an action for being valued at the references materializing step"
	
	referenceMaterializingActions add: aBlock ! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/28/2010 10:51'!
root

	^ materializedRoot ! !

!FLMaterializer methodsFor: 'accessing' stamp: 'MartinDias 10/6/2010 19:50'!
stream
	^ stream! !

!FLMaterializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 15:23'!
stream: aStream
	stream:= aStream.! !

Object subclass: #FLSerializer
	instanceVariableNames: 'stream instanceIndexes referenceSerializingActions postReferenceSerializingActions originalStream indexCluster'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core'!

!FLSerializer commentStamp: '<historical>' prior: 0!
I am a binary object serializer. 

By sending me #serializeAll: with a collection of objects as argument, I will write them on a byte stream, such that later a FLMaterializer instance will be able to read the stream and recreate the objects in the same or another image.!

!FLSerializer class methodsFor: 'instance creation' stamp: 'MartinDias 5/30/2011 02:55'!
newInMemorySizeHint: sizeHint

	^ self new
		initializeInMemoryWith: sizeHint;
		yourself.! !

!FLSerializer class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 5/18/2011 00:45'!
on: aWriteStream

	self flag: #todo "this 100 should be a setting".
	^ self on: aWriteStream hintSize: 100 bufferSize: 4096! !

!FLSerializer class methodsFor: 'instance creation' stamp: 'MartinDias 5/30/2011 03:02'!
on: aWriteStream hintSize: aNumber bufferSize: aBufferSize
	
	^ self new
		initializeOn: aWriteStream 
		hintSize: aNumber 
		bufferSize: aBufferSize;
		yourself.
	! !

!FLSerializer class methodsFor: 'serializing' stamp: 'MartinDias 5/30/2011 02:54'!
serialize: anObject toFileNamed: aFilename

	| serializer aFileStream |
 	aFileStream := (StandardFileStream fileNamed: aFilename) binary.
   	serializer := self on: aFileStream.
    	serializer serialize: anObject.
    	aFileStream close.
	! !

!FLSerializer class methodsFor: 'serializing' stamp: 'MartinDias 5/30/2011 02:54'!
serializeInMemory: anObject
	"No stream is needed by the user. An internal in-memory stream will be used. This method returns a ByteArray representing the serialization"
	
	^ (self newInMemorySizeHint: 100)
		serializeAndGetContents: anObject! !

!FLSerializer methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 5/27/2011 10:53'!
initializeInMemoryWith: sizeHiny

	"Usually, pre-allocating a collection is faster than make it grow. So we can have a default initial value"
	instanceIndexes := IdentityDictionary new: sizeHiny.
	referenceSerializingActions := OrderedCollection new.
	postReferenceSerializingActions := OrderedCollection new.
	originalStream := ByteArray new writeStream.
	stream := originalStream! !

!FLSerializer methodsFor: 'initialize-release' stamp: 'MartinDias 5/30/2011 03:02'!
initializeOn: aWriteStream hintSize: aNumber bufferSize: aBufferSize

	"Usually, pre-allocating a collection is faster than make it grow. So we can have a default initial value"
	instanceIndexes := IdentityDictionary new: aNumber.
	referenceSerializingActions := OrderedCollection new.
	postReferenceSerializingActions := OrderedCollection new.
	originalStream := aWriteStream.
	self flag: #todo. "when the settings is ready, we can direcly set to 'stream' the original one instead of this buffer'  "
	stream := FLBufferedWriteStream on: originalStream.
	stream sizeBuffer: aBufferSize.! !

!FLSerializer methodsFor: 'encoding' stamp: 'MartinDias 5/30/2011 02:49'!
nextPutIdOf: aCluster

	stream nextPut: aCluster class id! !

!FLSerializer methodsFor: 'encoding' stamp: 'MartinDias 5/30/2011 02:45'!
nextPutIndex: anInteger

	indexCluster 
		serialize: anInteger 
		on: stream! !

!FLSerializer methodsFor: 'encoding' stamp: 'MartinDias 5/30/2011 02:44'!
nextPutReferenceTo: anObject

	indexCluster 
		serialize: (instanceIndexes at: anObject) 
		on: stream! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 3/20/2011 22:19'!
postReferenceSerializingActionsAdd: aBlock
	"Adds an action for being valued at the references serializing step"
	
	postReferenceSerializingActions add: aBlock ! !

!FLSerializer methodsFor: 'accessing' stamp: 'MartinDias 10/15/2010 10:47'!
referenceSerializingActionsAdd: aBlock
	"Adds an action for being valued at the references serializing step"
	
	referenceSerializingActions add: aBlock ! !

!FLSerializer methodsFor: 'serializing' stamp: 'MartinDias 11/3/2010 15:28'!
serialize: anObject 
	"Serializes using the default analyzer"

	self serialize: anObject analyzer: FLAnalyzer newDefault! !

!FLSerializer methodsFor: 'serializing' stamp: 'MartinDias 5/30/2011 02:44'!
serialize: anObject analyzer: anAnalyzer
	"Main message for serializing"

	| objectCount clusteredObjects |
	anAnalyzer analyze: anObject.

	clusteredObjects := anAnalyzer clusteredObjects.
	objectCount := anAnalyzer objectCount.
	indexCluster := objectCount fuelCluster.

	self serializeHeaderWith: clusteredObjects and: objectCount.
	self serializeInstances: clusteredObjects.
	self serializeReferences.
	self serializeRoot: anObject.

	stream flush.
	self flag: #fix.  "this is an ugly hack beause benchmarks and test are wrong and reuses the same stream for serializing and maerializing"
	stream := originalStream.
	! !

!FLSerializer methodsFor: 'serializing' stamp: 'MarianoMartinezPeck 5/27/2011 10:57'!
serializeAndGetContents: anObject 
	"Serializes using the default analyzer"

	self serialize: anObject analyzer: FLAnalyzer newDefault.
	^ stream contents! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 5/30/2011 02:49'!
serializeHeaderWith: clusteredObjects and: objectCount

	self nextPutIdOf: indexCluster.
	self nextPutIndex: objectCount.
	self nextPutIndex: clusteredObjects size! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 5/30/2011 02:49'!
serializeInstances: clusteredInstances

	clusteredInstances
		do: [ :anAssociation | 
			| cluster instances |
			cluster := anAssociation key.
			instances := anAssociation value.

			instances do: [ :instance | instanceIndexes at: instance put: instanceIndexes size + 1 ].
			self nextPutIdOf: cluster.
			cluster serializeAll: instances with: self.
		]! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 3/20/2011 22:19'!
serializeReferences

	referenceSerializingActions 
		do: [ :aBlock | aBlock value ].
	postReferenceSerializingActions 
		do: [ :aBlock | aBlock value ]! !

!FLSerializer methodsFor: 'private' stamp: 'MartinDias 10/28/2010 10:36'!
serializeRoot: anObject

	self nextPutReferenceTo: anObject! !

!FLSerializer methodsFor: 'accessing' stamp: 'sd 9/8/2010 14:59'!
stream
	^ stream! !

Object subclass: #FLSimpleStack
	instanceVariableNames: 'array slotIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Collections'!

!FLSimpleStack class methodsFor: 'instance creation' stamp: 'MartinDias 5/15/2011 23:11'!
hintSize

	^64! !

!FLSimpleStack class methodsFor: 'instance creation' stamp: 'MartinDias 5/15/2011 23:11'!
new
	
	^ self new: self hintSize! !

!FLSimpleStack class methodsFor: 'instance creation' stamp: 'MartinDias 5/15/2011 23:09'!
new: nElements
	"Create a Set large enough to hold nElements without growing"
	^ self basicNew initialize: nElements! !

!FLSimpleStack methodsFor: 'accessing' stamp: 'MartinDias 5/15/2011 23:08'!
capacity

	^ array size! !

!FLSimpleStack methodsFor: 'adding' stamp: 'MartinDias 5/15/2011 23:15'!
grow
	"Become larger in capacity."
	| newArray |
	newArray := Array new: array size * 2.
	newArray replaceFrom: 1 to: array size with: array startingAt: 1.
	array := newArray! !

!FLSimpleStack methodsFor: 'initialize-release' stamp: 'MartinDias 5/15/2011 23:10'!
initialize: hintSize

	array := Array new: hintSize.
	slotIndex := 1.! !

!FLSimpleStack methodsFor: 'accessing' stamp: 'MartinDias 5/15/2011 22:54'!
isEmpty

	^ 1 = slotIndex! !

!FLSimpleStack methodsFor: 'removing' stamp: 'MartinDias 5/15/2011 22:52'!
pop
	"Returns the first element and remove it from the stack."

	slotIndex := slotIndex - 1.	
	^ array at: slotIndex ! !

!FLSimpleStack methodsFor: 'adding' stamp: 'MartinDias 5/15/2011 22:44'!
push: anObject 
	"Adds a new object of any kind on top of the stack."

	array at: slotIndex put: anObject.
	array size = slotIndex ifTrue: [ self grow ].
	slotIndex := slotIndex + 1.
	^ anObject.! !

Object subclass: #FLVariablesMapping
	instanceVariableNames: 'mapping actualClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Core-Clusters'!

!FLVariablesMapping commentStamp: 'MartinDias 11/15/2010 11:40' prior: 0!
I am used to materialize instance variables in an object, tolerating "class shape changing".

Cases tolerated are:
- instance variable added
- instance variable order change
- instance variable removed

Note: This class may be refactorized, because it looks a bit weird.!

!FLVariablesMapping class methodsFor: 'instance creation' stamp: 'MartinDias 4/21/2011 13:11'!
actualClass: aClass originalInstanceVariableNames: originalInstanceVariableNames 
	
	^ self basicNew
		initializeWith: originalInstanceVariableNames and: aClass;
		yourself.! !

!FLVariablesMapping methodsFor: 'accessing' stamp: 'MartinDias 4/21/2011 13:04'!
actualClass
	^ actualClass! !

!FLVariablesMapping methodsFor: 'accessing' stamp: 'MartinDias 4/21/2011 13:04'!
actualClass: anObject
	actualClass := anObject! !

!FLVariablesMapping methodsFor: 'initialize-release' stamp: 'MartinDias 4/21/2011 13:03'!
initializeWith: originalInstanceVariableNames and: aClass

	super initialize.
	
	actualClass := aClass.
	mapping := originalInstanceVariableNames 
		collect: [ :name | actualClass instVarIndexFor: name ifAbsent: [ nil ] ].

! !

!FLVariablesMapping methodsFor: 'accessing' stamp: 'MartinDias 4/21/2011 13:04'!
mapping
	^ mapping! !

!FLVariablesMapping methodsFor: 'accessing' stamp: 'MartinDias 4/21/2011 13:04'!
mapping: anObject
	mapping := anObject! !

!FLVariablesMapping methodsFor: 'materialize' stamp: 'MartinDias 11/12/2010 01:17'!
materializeReferencesOf: anObject with: aMaterializer 

	1 to: mapping size 
		do: [ :index | 
			| referencedObject mappedIndex |
			
			referencedObject := aMaterializer nextReferencedObject.
			mappedIndex := mapping at: index.
			
			mappedIndex ifNotNil: [ 
					anObject 
						instVarAt: mappedIndex 
						put: referencedObject ] ].! !

Object subclass: #FuelUtilities
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Fuel-Utilities'!

!FuelUtilities classSide methodsFor: 'as yet unclassified' stamp: 'MartinDias 5/30/2011 01:35'!
cleanUpEverything
	"Sometimes when updating Fuel versions Monticello gets stupid and we need to do some cleanups."
	Smalltalk garbageCollect.
	Smalltalk fixObsoleteReferences.
	FLCluster resetHierarchy.

	(PackageInfo named: 'Fuel') classes,
	(PackageInfo named: 'FuelFameExtension') classes,
	(PackageInfo named: 'FuelContainer') classes,
	(PackageInfo named: 'FuelMooseExtension') classes
	    do: [:c | c compileAll ].
	(PackageInfo named: 'Fuel') classes do: [:each | each initialize]
! !

!Object methodsFor: '*Fuel' stamp: 'MartinDias 9/27/2010 16:49'!
fuelAccept: aVisitor

	aVisitor visitObject: self.
! !

!Object methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster

	^ self class isVariable
		ifTrue: [ FLVariableObjectCluster for: self class ]
		ifFalse: [ FLFixedObjectCluster for: self class ]! !

!LargeNegativeInteger methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster 

	^ FLLargeNegativeIntegerCluster instance.! !

!LargePositiveInteger methodsFor: '*Fuel' stamp: 'MartinDias 5/30/2011 01:23'!
fuelCluster 

	^ FLLargePositiveIntegerCluster instance.! !
FLCluster initialize!
FLClassCluster initialize!
FLClassPoolAssociationMapper initialize!
FLGlobalMapper initialize!
FLNilTrueFalseCluster initialize!
